"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function dynamicOnChange(onChange) {
    return new Proxy({}, {
        get(target, key) {
            if (target[key] === undefined) {
                target[key] = (value) => {
                    onChange(key, value);
                };
            }
            return target[key];
        },
    });
}
exports.dynamicOnChange = dynamicOnChange;
exports.default = dynamicOnChange;
